import { CompleteStrategy } from './index';
import { SyntaxNode } from '@lezer/common';
import { CompletionContext, CompletionResult } from '@codemirror/autocomplete';
import { EditorState } from '@codemirror/state';
import { Matcher } from '../types';
import { DQLClient } from '../client';
export declare enum ContextKind {
    Namespace = 0,
    DColon = 1,
    Index = 2,
    DataSource = 3,
    ShowFunction = 4,
    FieldName = 5,
    FieldValue = 6,
    Function = 7,
    OuterFunction = 8,
    BinOp = 9,
    MatchOp = 10,
    ConnectOp = 11,
    Duration = 12,
    Offset = 13,
    SOffset = 14,
    Limit = 15,
    SLimit = 16,
    Orderby = 17,
    SOrderby = 18,
    By = 19,
    Number = 20,
    Desc = 21,
    Asc = 22
}
export interface Context {
    kind: ContextKind;
    Namespace?: string;
    Index?: string[];
    DataSource?: string[];
    matcher?: Matcher;
    isProjectField?: boolean;
    projectFields?: string[];
}
export declare function computeStartCompletePosition(state: EditorState, node: SyntaxNode, pos: number): number;
export declare function analyzeCompletion(state: EditorState, node: SyntaxNode, pos: number): Context[];
export declare class HybridComplete implements CompleteStrategy {
    private readonly dqlClient;
    constructor(dqlClient?: DQLClient);
    DQL(context: CompletionContext): Promise<CompletionResult | null> | CompletionResult | null;
    private autocompleteNamespace;
    private autocompleteIndex;
    private autocompleteDataSource;
    private autocompleteShowFuncs;
    private autocompleteFieldNames;
    private autocomplteFieldValues;
}
